/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef INSTPKGDBREADER_H
#define INSTPKGDBREADER_H

#include <QString>
#include <QObject>
#include <QProcess>

class QBsdPortInstPkg;

/* Processes the Database of installed packages */

class QInstPkgDbReader : public QObject
{
Q_OBJECT
private:
//     enum QProcess::ExitStatus int

    QProcess            *proc;

    QBsdPortInstPkg     *pkg;
    QString             origin;
    uint                counter;

public:
//     QInstPkgDbReader() : QObject()
//     { 
//         init(); 
//     }
//     QInstPkgDbReader() : QInstPkgDbReader(0) { }
    QInstPkgDbReader(QObject* parent=0);
    QInstPkgDbReader(const QInstPkgDbReader& n);


    void go();

public slots:
    void readStdOut();
    void readStdErr();
    void procFinished(int, QProcess::ExitStatus);

signals:
    void started();
    void finishedSuccessfully(uint);
    void failed(const QString&);
};
#endif //INSTPKGDBREADER_H