/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <QtGui>
#include <QTextEdit>
#include <QTextStream>
#include <QCloseEvent>
#include <QFileDialog>
#include <QMenuBar>

#include "bsdportglobal.h"
// #include "kportsglobal.h"
#include "kports.h"
#include "infopagewidget.h"




QBsdPortGlobal* QBsdPort::global = 0;
// KPortsGlobal* KPortsGlobal::kg = 0;

KPorts::KPorts()
{
    QIcon icon;
    QString path = PREFIX "/share/icons/hicolor/";
    if (QFile::exists(path + "16x16/apps/kports.png"))
        icon.addFile(path + "16x16/apps/kports.png", QSize(16,16) );
    if (QFile::exists(path + "22x22/apps/kports.png"))
        icon.addFile(path + "22x22/apps/kports.png", QSize(22,22) );
    if (QFile::exists(path + "32x32/apps/kports.png"))
        icon.addFile(path + "32x32/apps/kports.png", QSize(32,32) );
    if (QFile::exists(path + "256x256/apps/kports.png"))
        icon.addFile(path + "256x256/apps/kports.png", QSize(256,256) );
    QApplication::setWindowIcon(icon);
    this->setWindowTitle(APPTITLE);


    QBsdPort::global = new QBsdPortGlobal();
//     KPortsGlobal::kg = new KPortsGlobal();


    mainView = new KPortsView(this);
    setCentralWidget(mainView);

    connect(mainView->aboutButton,      SIGNAL(clicked()),
            this,                       SLOT(about()));
    connect(mainView->configureButton,  SIGNAL(clicked()),
            this,                       SLOT(configure()));
    connect(mainView->exitButton,       SIGNAL(clicked()),
            this,                       SLOT(close()));

    
    
    createActions();
    createMenus();
    createToolBars();
    createStatusBar();
    
    readSettings();
    
//    connect(textEdit->document(), SIGNAL(contentsChanged()),
//        this, SLOT(documentWasModified()));
    
}

void KPorts::closeEvent(QCloseEvent *event)
{
    if (maybeSave()) {
        writeSettings();
        event->accept();
    } else {
        event->ignore();
    }
}

void KPorts::about()
{
//     KPortsAboutDlg aboutDlg(this);
// 
//     aboutDlg.exec();



// //     QDialog* aboutDlg = new QDialog(this);
// //     aboutDlg->setModal(true);
// //     QVBoxLayout* layout = new QVBoxLayout(aboutDlg);
//     QInfoPageKPortsItem* about = new QInfoPageKPortsItem(0,
//                                   Qt::Window | Qt::Popup |Qt::WindowStaysOnTopHint );
// //     layout->addWidget(about);
//     about->move((this->width()-about->width())/2,
//                 (this->height()/*-about->height()*/)/2);
//     about->setWindowModality(Qt::ApplicationModal);
//      about->show();
// //     delete about;
// //     aboutDlg->exec();


    mainView->showAbout();
}

void KPorts::documentWasModified()
{
    setWindowModified(true);
}

void KPorts::createActions()
{
//     updateAct = new QAction(tr("Fetch &Updates"), this);
//     updateAct->setShortcut(tr("Ctrl+U"));
//     updateAct->setStatusTip(tr("Fetch Updates"));
// //    connect(updateAct, SIGNAL(triggered()), this, SLOT(updateFile()));
// 
//     installAct = new QAction(tr("&Install/Upgrade"), this);
//     installAct->setShortcut(tr("Ctrl+I"));
//     installAct->setStatusTip(tr("Install and/or upgrade selected Ports"));
// //    connect(installAct, SIGNAL(triggered()), this, SLOT(install()));
// 
//     removeAct = new QAction(tr("&Remove"), this);
//     removeAct->setShortcut(tr("Ctrl+R"));
//     removeAct->setStatusTip(tr("Removed selected Ports"));
// //    connect(removeAct, SIGNAL(triggered()), this, SLOT(remove()));
// 
// 
//     hideMenuBarAct = new QAction(tr("&HideMenuBar"), this);
//     hideMenuBarAct->setShortcut(tr("Ctrl+M"));
//     hideMenuBarAct->setCheckable(true);
//     hideMenuBarAct->setStatusTip(tr("show Menubar"));
//     connect(hideMenuBarAct, SIGNAL(toggled(bool)),
//             menuBar(), SLOT(setHidden(bool)));
// 
//     configureAct = new QAction(tr("&configure KPorts"), this);
//     configureAct->setIcon(KPortsIcons::iconLoader.loadIcon("configure"));
//     configureAct->setStatusTip(tr("configure KPorts"));
//     connect(configureAct, SIGNAL(triggered()), this, SLOT(configure()));
// 
//     aboutAct = new QAction(tr("&About"), this);
//     aboutAct->setIcon(KPortsIcons::iconLoader.loadIcon("about"));
//     aboutAct->setStatusTip(tr("about KPorts"));
//     connect(aboutAct, SIGNAL(triggered()), this, SLOT(about()));
// 
//     aboutQtAct = new QAction(tr("About &Qt"), this);
//     aboutQtAct->setStatusTip(tr("about Qt"));
//     connect(aboutQtAct, SIGNAL(triggered()), qApp, SLOT(aboutQt()));
// 
//     exitAct = new QAction(tr("E&xit"), this);
//     exitAct->setShortcut(tr("Ctrl+Q"));
//     exitAct->setStatusTip(tr("Exit"));
//     exitAct->setIcon(KPortsIcons::iconLoader.loadIcon("exit"));
//     connect(exitAct, SIGNAL(triggered()), this, SLOT(close()));

}

void KPorts::createMenus()
{
//     actionMenu = menuBar()->addMenu(tr("&Actions"));
//     actionMenu->addAction(updateAct);
//     actionMenu->addAction(installAct);
//     actionMenu->addAction(removeAct);
// 
//     menuBar()->addSeparator();
// 
//     appMenu = menuBar()->addMenu(tr("A&pplication"));
//     appMenu->addAction(aboutAct);
//     appMenu->addAction(aboutQtAct);
//     appMenu->addSeparator();
//     appMenu->addAction(hideMenuBarAct);
//     appMenu->addAction(configureAct);
//     appMenu->addAction(exitAct);

    menuBar()->hide();
}

void KPorts::createToolBars()
{
//     actionToolBar = addToolBar(tr("Action"));
//     actionToolBar->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
//     actionToolBar->addAction(updateAct);
//     actionToolBar->addAction(installAct);
//     actionToolBar->addAction(removeAct);
//     actionToolBar->hide();
//     
//     appToolBar = addToolBar(tr("Application"));
//     appToolBar->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
//     appToolBar->addAction(configureAct);
//     appToolBar->addAction(aboutAct);
//     appToolBar->addAction(exitAct);
//    appToolBar->hide();
}

void KPorts::createStatusBar()
{
//    connect((KPortsView*)mainView, SIGNAL(newStatusMsg(const QString&)),
//            this, SLOT(setStatusBarText(const QString&)));

//    statusBar()->hide();
//     if (!statusBar()->layout())
//         qDebug("blare");
//     else
//     {
// //        statusBar()->layout()->setContentsMargins(0,0,0,0);
// //        statusBar()->setMaximumHeight(20);
// //        statusBar()->setFixedHeight(statusBar()->sizeHint().height());
//     }

    QIndexTaskItem      *indexTaskItem    = new QIndexTaskItem(this);
    QPkgDbTaskItem      *pkgDbTaskItem    = new QPkgDbTaskItem(this);
    QFtpIndexTaskItem   *ftpIndexTaskItem = new QFtpIndexTaskItem(this);
    QSearchTaskItem     *searchTaskItem   = new QSearchTaskItem(this);
    QVulnaDbTaskItem    *vulnaDbTaskItem  = new QVulnaDbTaskItem(this);

    statusBar()->addPermanentWidget(vulnaDbTaskItem);
    statusBar()->addPermanentWidget(searchTaskItem);
    statusBar()->addPermanentWidget(indexTaskItem);
    statusBar()->addPermanentWidget(pkgDbTaskItem);
    statusBar()->addPermanentWidget(ftpIndexTaskItem);


}

void KPorts::readSettings()
{
    QSettings settings("kports", "kports");
    QPoint pos = settings.value("window/pos", QPoint(200, 200)).toPoint();
    QSize size = settings.value("window/size", QSize(500, 500)).toSize();
    resize(size);
    move(pos);
}

void KPorts::writeSettings()
{
    QSettings settings("kports", "kports");
    settings.setValue("window/pos", pos());
    settings.setValue("window/size", size());
}

bool KPorts::maybeSave()
{
/*    if (textEdit->document()->isModified()) {
        int ret = QMessageBox::warning(this, tr("Application"),
                tr("The document has been modified.\n"
                "Do you want to save your changes?"),
                QMessageBox::Yes | QMessageBox::Default,
                QMessageBox::No,
                QMessageBox::Cancel | QMessageBox::Escape);
        if (ret == QMessageBox::Yes)
        return false;//save();
        else if (ret == QMessageBox::Cancel)
        return false;
    }*/
    return true;
}

KPorts::~KPorts()
{

}



/*!
    \fn KPorts::configure()
 */
void KPorts::configure()
{
    KPortsConfigView configDlg(this);

    configDlg.exec();
}


/*!
    \fn KPorts::toggelMenuBar()
 */
void KPorts::toggleMenuBar()
{
    menuBar()->setVisible(!menuBar()->isVisible());
}

/*!
    \fn KPorts::setStatusBarText(const QString&)
    */
void KPorts::setStatusBarText(const QString& str)
{
        statusBar()->showMessage(str);
}