/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef KPORTS_H
#define KPORTS_H

#include <QMainWindow>
#include <QCloseEvent>
#include <QAction>
#include <QSettings>

#include "kportsview.h"
#include "kportsicons.h"
#include "kportsconfigview.h"
#include "taskwidgets.h"




class QMenu;


class KPorts: public QMainWindow
{
    Q_OBJECT

public:
    KPorts();
    ~KPorts();


protected:
    void closeEvent(QCloseEvent *event);

private slots:
    void about();
    void documentWasModified();
    void configure();
    void toggleMenuBar();

private:
    void createActions();
    void createMenus();
    void createToolBars();
    void createStatusBar();
    void readSettings();
    void writeSettings();
    bool maybeSave();

    KPortsView *mainView;

    QMenu *appMenu;
    QMenu *actionMenu;
    QToolBar *appToolBar;
    QToolBar *actionToolBar;
    QAction *exitAct;
    QAction *aboutAct;
    QAction *aboutQtAct;
    QAction *updateAct;
    QAction *installAct;
    QAction *removeAct;
    QAction *configureAct;
    QAction *hideMenuBarAct;

public slots:
    void setStatusBarText(const QString& str);
};


#endif
