/***************************************************************************
 *   Copyright (C) 2005-2009 by Hannes Hauswedell                          *
 *   kports@soulrebel.in-berlin.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef KPORTSCONFIGVIEW_H
#define KPORTSCONFIGVIEW_H



#include "ui_kportsconfigview.h"
#include "bsdportglobal.h"

//#include <QWidget>
//#include <QDialog>

#include <QSettings>
class QColor;
class QWidget;
//class QDialog;

/**
    @author Hannes Hauswedell <kports@soulrebel.in-berlin.de>
*/
class KPortsConfigView : public QDialog, public Ui::KPortsConfigView
{
Q_OBJECT
private:
    QSettings   *m_settings;
    QColor      m_fileModified,
                m_ports2BeRemoved,
                m_ports2BeImproved;
    
public:
    KPortsConfigView(QWidget *parent=0);

    ~KPortsConfigView()
    {
        delete m_settings;
    }


    inline QSettings *settings() const { return m_settings; }

    void readKPortsSettings();
    void readBpkSettings();

    void writeKPortsSettings();
    void writeBpkSettings();

public slots:
    inline void showAppearance() { stackedWidget->setCurrentIndex(0); }
    inline void showPaths()      { stackedWidget->setCurrentIndex(1); }
    inline void showMisc()       { stackedWidget->setCurrentIndex(2); }

    void buttonInBoxClicked(QAbstractButton*);
    void accepted();
    void colorChoserFileModified();
    void colorChoserPortImprove();
    void colorChoserPortRemove();

};

#endif //KPORTSCONFIGVIEW_H
