TEMPLATE    =   app

SOURCES     +=  main.cpp \
                kports.cpp \
                kportsglobal.cpp \
                kportsview.cpp \
                kportsconfigview.cpp \
                bsdport.cpp \
                bsdportglobal.cpp  \
                infopagewidget.cpp \
                instpkgdbreader.cpp \
                portstreemodel.cpp \
                kportsicons.cpp

HEADERS     +=  kports.h \
                kportsview.h \
                kportsconfigview.h \
                kportsglobal.h \
                bsdport.h \
                bsdportglobal.h \
                bsdportsearch.h \
                extrawidgets.h \
                infopagewidget.h \
                instpkgdbreader.h \
                portstreemodel.h \
                taskwidgets.h \
                kportsicons.h

CONFIG      +=  warn_on \
                thread \
                qt

RESOURCES   =  kports.qrc

FORMS       += kportsview.ui \
               kportsconfigview.ui
    
QT          += network

unix {
    isEmpty(PREFIX) {
        PREFIX = /usr/local
    }

    BINDIR      = $$PREFIX/bin
    SHAREDIR    = $$PREFIX/share
    isEmpty (DATADIR) {
        DATADIR     = $$SHAREDIR/kports
    }

    DEFINES += PREFIX=\\\"$$PREFIX\\\" DATADIR=\\\"$$DATADIR\\\"
}



TARGET      =  ../bin/kports
target.path = $$BINDIR

INSTALLS    += target

unix {
    icon16.path     =   $$SHAREDIR/icons/hicolor/16x16/apps
    icon16.files    +=  ../data/hicolor/16x16/kports.png
    INSTALLS        +=  icon16

    icon22.path     =   $$SHAREDIR/icons/hicolor/22x22/apps
    icon22.files    +=  ../data/hicolor/22x22/kports.png
    INSTALLS        +=  icon22

    icon32.path     =   $$SHAREDIR/icons/hicolor/32x32/apps
    icon32.files    +=  ../data/hicolor/32x32/kports.png
    INSTALLS        +=  icon32

    icon48.path     =   $$SHAREDIR/icons/hicolor/48x48/apps
    icon48.files    +=  ../data/hicolor/48x48/kports.png
    INSTALLS        +=  icon48

    icon64.path     =   $$SHAREDIR/icons/hicolor/64x64/apps
    icon64.files    +=  ../data/hicolor/64x64/kports.png
    INSTALLS        +=  icon64

    icon128.path     =   $$SHAREDIR/icons/hicolor/128x128/apps
    icon128.files    +=  ../data/hicolor/128x128/kports.png
    INSTALLS        +=  icon128
    
    icon256.path    =   $$SHAREDIR/icons/hicolor/256x256/apps
    icon256.files   +=  ../data/hicolor/256x256/kports.png
    INSTALLS        +=  icon256

    iconSVG.path    =   $$SHAREDIR/icons/hicolor/scalable/apps
    iconSVG.files   +=  ../data/hicolor/scalable/kports.svgz
    INSTALLS        +=  iconSVG

    desktop.path    =   $$SHAREDIR/applications
    desktop.files   +=  ../data/kports.desktop
    INSTALLS        +=  desktop
}
